//-----------------------------------------------------------------------
// File : FpsRenderer.h
// Desc : Frame Per Second Renderer
// Copyright(c) Project Asura All right reserved.
//-----------------------------------------------------------------------

//-----------------------------------------------------------------------
// History
//-----------------------------------------------------------------------
// <---> 2010/12/30 [Pocol] VK쐬.
// <End>

#ifndef __FPS_RENDERER_H__
#define __FPS_RENDERER_H__

//----------------------------------------------------------------------
// Includes
//----------------------------------------------------------------------
#include "AsDemoApp.h"
#include "AsTimer.h"


namespace Schaft {
namespace Asura {
namespace SampleProgram {

/////////////////////////////////////////////////////////////////////////
// FpsRenderer class
/////////////////////////////////////////////////////////////////////////
class FpsRenderer : public IRenderer
{
	//-------------------------------------------------------------------
	// list of friend classes
	//-------------------------------------------------------------------
	/* NOTHING */

public:
	//-------------------------------------------------------------------
	// public variables
	//-------------------------------------------------------------------
	/* NOTHING */

	//-------------------------------------------------------------------
	// public methods
	//-------------------------------------------------------------------
	FpsRenderer();
	virtual ~FpsRenderer();
	bool Initialize();
	void PreRender();
	void Render();
	void RenderAlpha();
	void PostRender();
	void Release();

protected:
	//-------------------------------------------------------------------
	// protected variables
	//-------------------------------------------------------------------
	/* NOTHING */

	//-------------------------------------------------------------------
	// protected methods
	//-------------------------------------------------------------------
	/* NOTHING */

private:
	//-------------------------------------------------------------------
	// private variables
	//-------------------------------------------------------------------
	char mFpsText[50];
	char mRendererText[50];
	char mVendorText[50];
	char mGLVerText[50];
	Schaft::Asura::Timer mTimer;
	unsigned int mFrame;
	double       mLastTime;

	//-------------------------------------------------------------------
	// private methods
	//-------------------------------------------------------------------
	void RenderText( const char* text );
};

} // namespace SampleProgram
} // namespace Asura
} // namespace Schaft

#endif // __FPS_RENDERER_H__