//----------------------------------------------------------------------
// File : SampleRenderer.h
// Desc : Sample Renderer
// Copyright(c) Project Asura All right reserved.
//----------------------------------------------------------------------

//----------------------------------------------------------------------
// History
//----------------------------------------------------------------------
// <---> 2011/02/19 [Pocol] VK쐬.
// <End>

#ifndef __SAMPLE_RENDERER_H__
#define __SAMPLE_RENDRERE_H__

//----------------------------------------------------------------------
// Includes
//----------------------------------------------------------------------
#include "AsDemoApp.h"
#include "AsMath.h"
#include "AsShaderHelper.h"

namespace Schaft {
namespace Asura {
namespace SampleProgram {

////////////////////////////////////////////////////////////////////////
// SampleRenderer class
////////////////////////////////////////////////////////////////////////
class SampleRenderer : public IRenderer
{
    //------------------------------------------------------------------
    // list of friend classes and methods
    //------------------------------------------------------------------
    /* NOTHING */

public:
    //------------------------------------------------------------------
    // public variables
    //------------------------------------------------------------------
    /* NOTHING */

    //------------------------------------------------------------------
    // public methods
    //------------------------------------------------------------------
    SampleRenderer();
    virtual ~SampleRenderer();
    bool Initialize();
    void PreRender();
    void Render();
    void RenderAlpha();
    void PostRender();
    void Release();

protected:
    //------------------------------------------------------------------
    // protected variables
    //------------------------------------------------------------------
    /* NOTHING */

    //------------------------------------------------------------------
    // protected methods
    //------------------------------------------------------------------
    /* NOTHING */

private:
    //------------------------------------------------------------------
    // private variables
    //------------------------------------------------------------------
    Schaft::Asura::Graphics::ICgEffect* mpEffect;
    Schaft::Asura::Math::Matrix mWorld;
    Schaft::Asura::Math::Matrix mView;
    Schaft::Asura::Math::Matrix mProjection;
    Schaft::Asura::Math::Vector3 mLightPosition;
    Schaft::Asura::Math::Vector3 mCameraPosition;
    CGparameter mEhLightPosition;
    CGparameter mEhCameraPosition;
    CGparameter mEhWorld;
    CGparameter mEhView;
    CGparameter mEhProjection;
    uint32_t mVB[3];
    uint32_t mIB;
    int      mNumIndices;

    //------------------------------------------------------------------
    // private methods
    //------------------------------------------------------------------
    void CreateObject( int l, int m );
};

} // namespace SampleProgram
} // namespace Asura
} // namespace Schaft

#endif // __SAMPLE_RENDERER_H__