//----------------------------------------------------------------------
// File : SHCalculator.h
// Desc : Spherical Harmonics Calcualtor
// Copyright(c) Project Asura All right reserved.
//----------------------------------------------------------------------

//----------------------------------------------------------------------
// History
//----------------------------------------------------------------------
// <---> 2011/02/19 [Pocol] VK쐬.
// <End>

#ifndef __SH_CALCULATOR_H__
#define __SH_CALCULATOR_H__

//----------------------------------------------------------------------
// Includes
//----------------------------------------------------------------------
#include "AsMath.h"

namespace Schaft {
namespace Asura {
namespace SampleProgram {

////////////////////////////////////////////////////////////////////////
// SHCalculator class
////////////////////////////////////////////////////////////////////////
class SHCalculator
{
    //------------------------------------------------------------------
    // list of friend classes and methods.
    //------------------------------------------------------------------
    /* NOTHING */

public:
    //------------------------------------------------------------------
    // public variables
    //------------------------------------------------------------------
    /* NOTHING */

    //------------------------------------------------------------------
    // public methods
    //------------------------------------------------------------------
    static float Compute( int l, int m, float theta, float phi );

protected:
    //-------------------------------------------------------------------
    // protected variables
    //-------------------------------------------------------------------
    /* NOTHING */

    //-------------------------------------------------------------------
    // protected methods
    //-------------------------------------------------------------------
    static float ScalingFactor( int l, int m );
    static float LegendrePolynomials( int l, int m, float x );

private:
    //-------------------------------------------------------------------
    // private variables
    //-------------------------------------------------------------------
    /* NOTHING */

    //-------------------------------------------------------------------
    // private methods
    //-------------------------------------------------------------------
    /* NOTHING */
};

} // namespace SampleProgram
} // namespace Asura
} // namespace Schaft



#endif // __SH_CALCULATOR_H__